world.startDebugMode();

refObject._previous_state = null;

function next_counter(obj) {
	//FIXME: use getSnappedObject when implemented in TP
	let pos = obj.getAllSnapPoints()[1]
		.getGlobalPosition()
		.divide(9)
		.add(obj.getRotation().getRightVector());

	return world.sphereOverlap(pos, 0.1)[0];
}

function prev_counter(obj) {
	//FIXME: use getSnappedObject when implemented in TP
	let pos = obj.getAllSnapPoints()[0]
		.getGlobalPosition()
		.divide(9)
		.add(obj.getRotation().getRightVector().multiply(-1));

	return world.sphereOverlap(pos, 0.1)[0];
}

refObject.onNumberAction.add(function (obj, player, number) {
	let counters = [obj];

	for (let i = 0; i < 999; i++) {
		let left_counter = prev_counter(counters[0]);
		if (left_counter === undefined) {
			break;
		} else {
			counters.unshift(left_counter);
			first_counter = left_counter;
		}
	}

	for (let i = 0; i < 999; i++) {
		let right_counter = next_counter(counters[counters.length-1]);
		if (right_counter === undefined) {
			break;
		} else {
			counters.push(right_counter)
			last_counter = right_counter;
		}
	}

	let i = 0;
	for (const counter of counters) {
		let digit = Math.floor(number % (10**(counters.length-i)) / (10**(counters.length-i-1)));
		counter.setState(digit);
		i++;
	}
});

refObject.onStateChanged.add(function (obj, new_state, old_state) {
	obj._previous_state = old_state;
});

function inc_prev(obj) {
	let prev = prev_counter(obj);
	if (prev !== undefined) {
		let digit = prev.getState();
		if (digit === 9) {
			prev.setState(0);
			inc_prev(prev);
		} else {
			prev.setState(digit + 1);
		}
	}
}

function dec_prev(obj) {
	let prev = prev_counter(obj);
	if (prev !== undefined) {
		let digit = prev.getState();
		if (digit === 0) {
			prev.setState(9);
			dec_prev(prev);
		} else {
			prev.setState(digit - 1);
		}
	}
}

refObject.onPrimaryAction.add(function (obj, player) {
	let digit = obj.getState();
	if (digit === 9 && obj._previous_state === 9) {
		obj.setState(0);
		inc_prev(obj);
	}
});

refObject.onSecondaryAction.add(function (obj, player) {
	let digit = obj.getState();
	if (digit === 0 && obj._previous_state === 0) {
		obj.setState(9);
		dec_prev(obj);
	}
});
